# SparseFA : simulation
# experiments on simulated data

from vbfa import *
import scipy as SP
from mlib.utils import *
from sparseFA import *
import scipy
import scipy.stats
import scipy.io
import os
import logging as L
import pylab as PL
import time


if __name__ =='__main__':

    out_base ='/home/os252/work/bio/sparseFA/Data/DataUAI/Toy_1000_100_50'


    if 0:
        Ntf = 20
        Ngenes = 486
        Nind = 20

        FPR = 0.3
        FNR = 0.3

    if 1:
        Ntf = 60
        Ngenes = 800
        Nind = 100

        FPR = 0.05
        FNR = 0.10

    

    #gamma
    loc = 1
    scale = 100
    noise_prec = scipy.stats.gamma.rvs(loc,scale,size=Ngenes)
    noise_std  = S.sqrt(1/noise_prec)

    #1. load yeastract data
    yt_file = "/home/os252/work/sanger-bio/data/old/yeast/data/yeast/chip-chip/yeastract/yeastract.mat"
    yt_dump = yt_file +'.pickle'
    if os.path.exists(yt_dump):
        yt = cPickle.load(open(yt_dump,'rb'))
    else:
        yt = scipy.io.loadmat(yt_file)
        cPickle.dump(yt,open(yt_dump,'wb'),-1)


    #1. draw a couple of TFs
    Cy = yt['data']
    [NtfC,NgenesC] = Cy.shape

    Itf = random.permutation(NtfC)[0:Ntf]
    Igene = random.permutation(NgenesC)[0:Ngenes]

    #subset
    Cy = Cy[Itf,:][:,Igene]>0

    #switch a few more on
    Ct = random.rand(Ntf,Ngenes)<0.02
#   Cy[Ct] = True

    if 0:
        #load data from kevin
        mat_file = './../Data/DataUAI/Toy_486_20_20/X_PI_Y_AlphaY_BetaY.mat'
        mat_file_true  = os.path.join('./../Data/DataUAI/Toy_486_20_20/SubnetData.mat')
        data      = scipy.io.loadmat(mat_file)
        data_tru      = scipy.io.loadmat(mat_file_true)['SubnetData']
        Pi = data['Pi'].T
    else:
        #create Pi
        Pi = S.ones(Cy.shape,dtype='float')
        Pi*= (1-FPR)
        Pi[~Cy] = FNR

    #draw a connectivity matrix
    C = random.rand(Pi.shape[0],Pi.shape[1])<Pi

    #2. draw random factor axtivations
    X = random.randn(Nind,Ntf)

    #3. draw weights from mixture prior
    W = random.randn(Ngenes,Ntf)
    #4. set all false values to 0
    W[~C.T] = 0

    #5. simulate signal
    Z = dot(X,W.T)
    #6. simulate noise
    psi = random.randn(Nind,Ngenes)*noise_std

    Y = Z + psi

    #test
    if 0:
        Y = dot(data_tru.X*data_tru.A,data_tru.C).T+psi
        C = data_tru.X.T
    

    if 1:
    #7. resemble matlab simulation structure and save all that
        mat_data = {'Pi': Pi.T, 'Y': Y.T}
        true_data = {'Y':Y.T,'A':W,'C':X.T,'X':C.T,'Pi':Pi.T}
    if 0:
        #mat_data = {'Pi':data['Pi'],'Y': data['Y']}
        true_data = {'A':data_tru.A,'C':data_tru.C,'X':data_tru.X,'Pi':data_tru.Pi}


    out_data = os.path.join(out_base,'X_PI_Y_AlphaY_BetaY.mat')
    out_data_true = os.path.join(out_base,'SubnetData.mat')
    scipy.io.savemat(out_data,mat_data)
    scipy.io.savemat(out_data_true,true_data)
