# SparseFA : Replica theory experiments for Magnus


import sys
import scipy as SP
from mlib.utils import *
from sparseFA import *
import scipy
import scipy.io
import os
import logging as L
import pylab as PL
import time
import pdb
import pp


def run_replica_experiment(data,sparsity='EPV',s2= 1E-3,nIterations=10, priors = {'Eps':{'priors': [1,10]}},initType='prior'):
    import sys
    sys.path.append('/kyb/agbs/stegle/work/sparseFA/pysrc/newSparseFA')
    import scipy as SP
    import sparseFA
    import scipy
    import scipy.io
    import os
    import logging as L
    import pylab as PL
    import time
    import pdb
    import pp

    """run replica experiment for magnus"""
    #1. get data needed from structure
    x = data.x.T
    b = data.b
    z = data.z
    C = data.C[0,0]
    Son = data.Son[0,0]
    #initialize object and start experiment
    Pi = SP.zeros([b.shape[0],1])
    Pi[:,:] = C
    init={'init_data':sparseFA.CGauss(x),'Pi':Pi}
    FA = sparseFA.CSparseFA(components=1,sigmaOff=s2,sigmaOn=Son,sparsity=sparsity,nIterations=nIterations,priors=priors,initType=initType)
    FA.init(**init)
    FA.iterate()
    W = FA.W.E1
    q = SP.dot(W.T,W)
    r = SP.dot(W.T,b)
    t = SP.dot(b.T,b)
    corr = abs(r/SP.sqrt(q*t))
    loglik = (-SP.log(1+q)+(q+r**2)/(1+q))/2.0
    return {'corr': corr, 'loglik': loglik}
    pass


if __name__ =='__main__':
    L.getLogger().setLevel(L.INFO)
    random.seed(2)

    data_base = '/Volumes/HD2-Oliver-MP/data/work/sparseFA'
    out_base = '/Volumes/HD2-Oliver-MP/data/work/sparseFA'

    #intialise pp
    ppservers = ()
    ppservers = ("terek","ural","ebro")
    ncpus=0
    job_server = pp.Server(ncpus,ppservers=ppservers)
    print "Starting pp with", job_server.get_ncpus(), "workers"
    

    # in and out files:
    if 0:
        datafile = 'VBEPdata95.mat'
        outfile  = 'VBEPout95.mat'
    if 1:
        datafile = 'VBEPdata90.mat'
        outfile  = 'VBEPout90.mat'
    if 0:
        datafile ='VBEPdata80.mat'
        outfile  ='VBEPout80_s2.mat'
        
    
    #1. load the data
    R=scipy.io.loadmat(os.path.join(data_base,datafile))
    data_list=R['data_list']
    ###TMP: short cut the list
    #data_list = data_list[:,0:1,0:1]
    #pdb.set_trace()

    priors = {'Eps':{'priors': [1,10]}}
    #fix prior noise varaince to 1 
    priors = {'Eps':{'priors': 1}}
    nIterations=50
    initType = 'prior'
    initType = 'on'
    sparsity='EPV'
    s2 = 1E-3
    s2 = 1E-1


    #data_list = data_list[0:1,:,:]
    #2. create resul list
    job_list = SP.zeros(data_list.shape,dtype='object')
    result_list = SP.zeros(data_list.shape,dtype='object')

    job_list = SP.zeros(data_list.shape[1],dtype='object')
    #3. go through all entries and run the required experiments
    if 0:
        for i in xrange(data_list.shape[0]):
            for j in xrange(data_list.shape[1]):
                for k in xrange(data_list.shape[2]):
                    result_list[i,j,k] = run_replica_experiment(data_list[i,j,k][0][0],sparsity,s2,nIterations,priors,initType) 

    if 1:
        #parallelized version
        print "submitting jobs"
        for i in xrange(data_list.shape[0]):
            for k in xrange(data_list.shape[2]):
                for j in xrange(data_list.shape[1]):
                    job_list[j] = job_server.submit(run_replica_experiment,(data_list[i,j,k][0][0],sparsity,s2,nIterations,priors,initType))
                print "gathering results [i,k] - [%d,%d]" % (i,k)
                for j in xrange(data_list.shape[1]):
                    result_list[i,j,k] = job_list[j]()
                

                    
                
    #4. dump results
    #pdb.set_trace()
    scipy.io.savemat(os.path.join(out_base,outfile),{'result_list':result_list})

    ##the end##
    
                

